SystemOrganization addCategory: #'Magritte-JQueryWidgetBox-Tests'!
SystemOrganization addCategory: #'Magritte-JQueryWidgetBox'!
SystemOrganization addCategory: #'Magritte-JQueryWidgetBox-NFG'!

!MADescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/31/2011 20:48'!
replaceId
	^self propertyAt: #replaceId ifAbsent: [ nil ]! !

!MADescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/31/2011 20:48'!
replaceId: aSymbol
	self propertyAt: #replaceId put: aSymbol! !

!MADescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/31/2011 20:49'!
replaceIds
	^self propertyAt: #replaceIds ifAbsent: [ #() ]! !

!MADescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/31/2011 20:49'!
replaceIds: anArray
	self propertyAt: #replaceIds put: anArray! !

WAComponent subclass: #MJFunctionalTest
	instanceVariableNames: 'model component'
	classVariableNames: 'SearchObjects'
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-Tests'!

!MJFunctionalTest class methodsFor: 'as yet unclassified' stamp: 'jmck 3/8/2011 20:05'!
buildSearchObjects
	^OrderedCollection new
		add: (MJSearchObject new testValue: 'abcdef'; lookupValue: 'lookup1'; replace1: '1'; replace2: '2'; yourself);
		add: (MJSearchObject new testValue: 'abcfed'; lookupValue: 'lookup2'; replace1: '3'; replace2: '4'; yourself);
		add: (MJSearchObject new testValue: 'abdef'; lookupValue: 'lookup3'; replace1: '5'; replace2: '6'; yourself);
		add: (MJSearchObject new testValue: 'abddef'; lookupValue: 'lookup4'; replace1: '7'; replace2: '8'; yourself);
		add: (MJSearchObject new testValue: 'abefg'; lookupValue: 'lookup5'; replace1: '9'; replace2: '10'; yourself);
		add: (MJSearchObject new testValue: 'abfdef'; lookupValue: 'lookup6'; replace1: '11'; replace2: '12'; yourself);
		yourself
		! !

!MJFunctionalTest class methodsFor: 'as yet unclassified' stamp: 'jmck 3/8/2011 20:57'!
initialize
	"self initialize"
	| app |
	app := WAAdmin register: self asApplicationAt: 'jquery-widgets/magritte'.
	app addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQBaseTheme;
		addLibrary: JQWidgetBoxDeploymentLibrary;
		yourself.
		
	SearchObjects := self buildSearchObjects! !

!MJFunctionalTest methodsFor: 'as yet unclassified' stamp: 'jmck 3/8/2011 21:01'!
buildComponent
	^model asComponent! !

!MJFunctionalTest methodsFor: 'as yet unclassified' stamp: 'JohnMcKeon 10/4/2010 21:33'!
children
	^Array with: self component! !

!MJFunctionalTest methodsFor: 'as yet unclassified' stamp: 'JohnMcKeon 10/4/2010 21:33'!
component
	^component ifNil: [ component := self buildComponent ]! !

!MJFunctionalTest methodsFor: 'as yet unclassified' stamp: 'jmck 1/29/2011 12:52'!
initialize
	super initialize.
	model := MJMockObject new! !

!MJFunctionalTest methodsFor: 'as yet unclassified' stamp: 'jmck 1/28/2011 21:16'!
renderContentOn: html
	html heading level: 3; with: 'Magritte JQuery Functional Test'.
	html horizontalRule.
	html render: self component.
	html horizontalRule.
	model date isNil
		ifFalse: [ html paragraph: 'The Date is: ', model date asString ].
	html break.
	model time isNil
		ifFalse: [ html paragraph: 'The Time is: ', model time asString ].
	model searchobject isNil
		ifFalse: [ html paragraph: 'Selected object: ', model searchobject asString ]! !

MAPriorityContainer subclass: #MJTabsContainer
	instanceVariableNames: 'groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-NFG'!

!MJTabsContainer methodsFor: 'private' stamp: 'jmck 12/20/2010 22:17'!
buildChildren
	^self description
		inject: Dictionary new
		into: [ :result :desc | | group |
			(result at: (group := desc group) ifAbsentPut: MAContainer new) add: desc. result ]! !

!MJTabsContainer methodsFor: 'private' stamp: 'jmck 2/12/2011 16:00'!
buildGroups
	| group container |
	group := ''.
	^self children
		inject: Dictionary new
		into: [ :result :desc |
			desc group = group
				ifFalse: [
					group := desc group.
					container := result at: group put: MAContainer new ].
			container add: desc ]! !

!MJTabsContainer methodsFor: 'accessing' stamp: 'jmck 1/20/2011 18:47'!
componentClass
	^MJTabsComponent! !

!MJTabsContainer methodsFor: 'accessing' stamp: 'jmck 1/20/2011 18:46'!
componentRenderer
	^MJTabsRenderer! !

!MJTabsContainer methodsFor: 'accessing' stamp: 'jmck 12/19/2010 12:34'!
groups
	^groups ifNil: [ groups := self buildGroups ]! !

MATextInputComponent subclass: #MJDatepickerComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox'!

!MJDatepickerComponent commentStamp: 'jmck 1/28/2011 18:58' prior: 0!
A MJDatepickerComponent is Magritte component for looking up a date on a MADateDescription using the jQuery datepicker.

Instance Variables
!

!MJDatepickerComponent methodsFor: 'rendering' stamp: 'jmck 1/31/2011 18:06'!
renderInputOn: html
	html textInput
		attributeAt: 'autocomplete' put: 'off';
		id: self labelId;
		on: #string of: self;
		script: (html jQuery new datepicker
			onSelect: (html jQuery ajax serializeThis))! !

MATextInputComponent subclass: #MJTimepickrComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox'!

!MJTimepickrComponent commentStamp: 'jmck 1/28/2011 19:02' prior: 0!
A MJTimepickrComponent is Magritte component for entering a time on a field described by a MATimeDescription using the jQuery timepickr. JQueryWidgetBox-Timepickr is required to use this component.

Instance Variables
!

!MJTimepickrComponent methodsFor: 'rendering' stamp: 'jmck 2/21/2011 23:10'!
renderInputOn: html
	html textInput
		id: self labelId;
		attributeAt: 'autocomplete' put: 'off';
		on: #string of: self;
		script: (html jQuery new timepickr
			trigger: 'focus';
			select: (html jQuery ajax serializeThis))! !

!MJTimepickrComponent methodsFor: 'rendering' stamp: 'jmck 2/8/2011 19:23'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot javascript url: JQWidgetBoxDeploymentLibrary / #timepickrJs.
	anHtmlRoot stylesheet url: JQWidgetBoxDeploymentLibrary / #timepickrCss.! !

!MAComponent methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 2/1/2011 20:14'!
replaceId
	^self description replaceId! !

MAOneToManyComponent subclass: #MJGridComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-NFG'!

!MJGridComponent class methodsFor: 'as yet unclassified' stamp: 'jmck 12/18/2010 14:41'!
isAbstract
	^false! !

!MJGridComponent methodsFor: 'private' stamp: 'jmck 12/19/2010 00:22'!
buildColumns
	| columns |
	columns := JQGridColumns new.
	self reference do: [ :desc |
		columns add: ((JQGridColumn
			id: desc label
			label: desc label
			selector: [ :object | (object readUsing: desc) greaseString ])
				"sortable: desc isSortable;"
				editable: desc isReadonly not;
				edittype: desc componentClass edittype;
				editoptions: ((desc respondsTo: #options) ifTrue: [ desc options asJson ] ifFalse: [ nil ]);
				width: desc width; 
				parseBlock: [ :aString | desc fromString: aString ];
				sortId: desc label;
				yourself) ].
	^columns
! !

!MJGridComponent methodsFor: 'rendering' stamp: 'jmck 12/19/2010 00:50'!
doSearch: aSearchRequest using: jqGridColumns
	|filteredData sortedData pagedAndSortedData jqSortColumn|
	jqSortColumn := jqGridColumns columnForSearchRequest: aSearchRequest.
	filteredData := self value.
	aSearchRequest filterCriteriaDo: 
		[:aFilterCrit|
			filteredData 
				removeAllSuchThat: 
					[:each|
						((aFilterCrit jqGridColumn dataValueFor: each)
							perform: aFilterCrit operation with: aFilterCrit filterValue) not]].
	sortedData := 
		filteredData asSortedCollection:
			[:a :b| 
				((jqSortColumn dataValueFor: a) <= (jqSortColumn dataValueFor: b))
					xor: aSearchRequest isSortDescending].
	pagedAndSortedData := sortedData
		copyFrom: aSearchRequest startElementIndex 
		to: ((aSearchRequest endElementIndex) min: filteredData size).
	^JQGridSearchResponse new
		page: aSearchRequest pageNumber;
		totalNumberOfPages: (filteredData size / aSearchRequest numberOfRowsPerPage);
		totalNumberOfRecords: filteredData size;
		rowContents: 
			(pagedAndSortedData 
					collect: [:eachInvoice|
						JQGridRowContent new
							id: eachInvoice id;
							rowObject: eachInvoice])! !

!MJGridComponent methodsFor: 'rendering' stamp: 'jmck 12/19/2010 00:51'!
renderViewerOn: html

	html table
		id: self labelId;
		script: (html jQuery this grid
			searchCallback: [:aSearchRequest :jqGridColumns| self doSearch: aSearchRequest using: jqGridColumns];
			columns: self buildColumns;
			altRows: true;
			rowNum: 20;
			rowList: {5. 10. 20};
			pagerId: 'pager';
			sortname: self reference children first label;
			"toolbarSearch;"
			caption: self description label);
		with:''.
	html div id:'pager'; with: ''.
! !

MAFormDecoration subclass: #MJFormDecoration
	instanceVariableNames: 'scriptBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox'!

!MJFormDecoration methodsFor: 'initialization' stamp: 'jmck 3/6/2011 00:58'!
initialize
	super initialize.
	scriptBlock := [ :r | ]! !

!MJFormDecoration methodsFor: 'rendering' stamp: 'jmck 3/6/2011 12:51'!
renderButtonsOn: html
	html div class: 'buttons'; with: [
		self buttons do: [ :each |
			html anchor
				class: 'button';
				accessKey: each value first;
				callback: [ self execute: each key ];
				onClick: (html jQuery ajax
					serializeForm;
					script: [ :s | s << self scriptButtonOn: html ]);
				text: each value ] ]! !

!MJFormDecoration methodsFor: 'rendering' stamp: 'jmck 3/6/2011 00:57'!
scriptBlock
	^scriptBlock! !

!MJFormDecoration methodsFor: 'rendering' stamp: 'jmck 3/6/2011 00:57'!
scriptBlock: aBlock
	scriptBlock := aBlock! !

!MJFormDecoration methodsFor: 'rendering' stamp: 'jmck 3/6/2011 01:47'!
scriptButtonOn: html
	^html jQuery ajax
		serializeThis;
		script: [ :s | self scriptBlock value: s ]! !

MAComponentRenderer subclass: #MJTabsRenderer
	instanceVariableNames: 'selectedGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-NFG'!

!MJTabsRenderer methodsFor: 'rendering' stamp: 'jmck 12/20/2010 22:25'!
renderContainer: aDescription 
	self halt.
	html div
		class: (self classFor: aDescription);
		script: (html jQuery new tabs
			selected: selectedGroup;
			onSelect: (html jQuery ajax 
            		callbackTabs: [ :event | selectedGroup := event at: #index ]));
      with: [
         html unorderedList: [
            aDescription groups keysAndValuesDo: [ :name :group |
               html listItem: [
                  html anchor
                     url: (html jQuery ajax
                        html: [ :h | h render: group ];
                        fullUrl);
                     with: name ] ] ] ]! !

!MJTabsRenderer methodsFor: 'rendering' stamp: 'jmck 12/19/2010 12:51'!
renderControl: aDescription
	html definitionData
		class: (self classFor: aDescription);
		with: [ super renderControl: aDescription ]! !

!MJTabsRenderer methodsFor: 'rendering' stamp: 'jmck 12/19/2010 12:51'!
renderGroup: aDescription
	super renderGroup: aDescription.
	group isNil ifTrue: [ ^ self ].
	html definitionTerm
		class: 'group';
		with: group! !

!MJTabsRenderer methodsFor: 'rendering' stamp: 'jmck 12/19/2010 12:51'!
renderLabel: aDescription
	html definitionTerm
		title: aDescription comment;
		class: (self classFor: aDescription);
		with: [ super renderLabel: aDescription ]! !

!MAContainerComponent methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 3/6/2011 01:02'!
scriptForm
	self scriptForm: #(save cancel)
	! !

!MAContainerComponent methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 3/6/2011 01:01'!
scriptForm: aCollection
	self addDecoration: (MJFormDecoration buttons: aCollection)
	! !

!MAContainerComponent methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 3/6/2011 01:16'!
scriptForm: aCollection withScript: aBlock
	self addDecoration: (MJFormDecoration new
		addButtons: aCollection;
		scriptBlock: aBlock;
		yourself)
	! !

MAContainerComponent subclass: #MJTabsComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-NFG'!

!MJTabsComponent methodsFor: 'as yet unclassified' stamp: 'jmck 12/20/2010 22:02'!
buildChildren
	^self description groups associations
		inject: Dictionary new
		into: [ :result :group | 
			result at: group key put: group value asComponent. result ]! !

Object subclass: #MJMockObject
	instanceVariableNames: 'date time searchobject replace1 replace2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-Tests'!

!MJMockObject class methodsFor: 'accessing' stamp: 'jmck 1/20/2011 18:44'!
descriptionDate
	^MADateDescription new
		accessor: #date;
		label: 'Date';
		componentClass: MJDatepickerComponent;
		priority: 10;
		yourself! !

!MJMockObject class methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:29'!
descriptionObject
	^MAToOneRelationDescription new
		accessor: #searchobject;
		label: 'Object';
		classes: (Array with: MJSearchObject);
		componentClass: MJAutocompleteComponent;
		searchFields: #(#testValue);
		listFields: #(#testValue);
		updateId: #lookup;
		replaceIds: #(#replace1 #replace2);
		priority: 1;
		yourself! !

!MJMockObject class methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:03'!
descriptionReplace1
	^MAStringDescription new
		accessor: #replace1;
		label: 'Replace1';
		replaceId: #replace1;
		priority: 2;
		yourself! !

!MJMockObject class methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:29'!
descriptionReplace2
	^MAStringDescription new
		accessor: #replace2;
		label: 'Replace2';
		replaceId: #replace2;
		priority: 2;
		yourself! !

!MJMockObject class methodsFor: 'accessing' stamp: 'jmck 1/20/2011 18:45'!
descriptionTime
	^MATimeDescription new
		accessor: #time;
		label: 'Time';
		componentClass: MJTimepickrComponent;
		priority: 20;
		yourself! !

!MJMockObject methodsFor: 'accessing' stamp: 'JohnMcKeon 10/4/2010 20:46'!
date
	"Answer the value of date"

	^ date! !

!MJMockObject methodsFor: 'accessing' stamp: 'JohnMcKeon 10/4/2010 20:46'!
date: anObject
	"Set the value of date"

	date := anObject! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:03'!
replace1
	"Answer the value of replace1"

	^ replace1! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:03'!
replace1: anObject
	"Set the value of replace1"

	replace1 := anObject! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:03'!
replace2
	"Answer the value of replace2"

	^ replace2! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:03'!
replace2: anObject
	"Set the value of replace2"

	replace2 := anObject! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 1/28/2011 20:31'!
searchobject
	"Answer the value of searchobject"

	^ searchobject! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 1/28/2011 20:31'!
searchobject: anObject
	"Set the value of searchobject"

	searchobject := anObject! !

!MJMockObject methodsFor: 'accessing' stamp: 'JohnMcKeon 10/4/2010 20:46'!
time
	"Answer the value of time"

	^ time! !

!MJMockObject methodsFor: 'accessing' stamp: 'JohnMcKeon 10/4/2010 20:46'!
time: anObject
	"Set the value of time"

	time := anObject! !

Object subclass: #MJSearchObject
	instanceVariableNames: 'testValue lookupValue replace1 replace2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-Tests'!

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/29/2011 11:22'!
descriptionLookup
	| result |
	result := MAContainer new
		add: self descriptionLookupValue;
		componentRenderer: MACssRenderer;
		yourself.
	^result
		! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/29/2011 11:22'!
descriptionLookupValue
	^MAStringDescription new
		accessor: #lookupValue;
		label: '';
		beReadonly;
		priority: 10;
		yourself! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/29/2011 10:41'!
lookupValue
	"Answer the value of lookupValue"

	^ lookupValue! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/29/2011 10:41'!
lookupValue: anObject
	"Set the value of lookupValue"

	lookupValue := anObject! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/28/2011 19:55'!
printOn: aStream
	aStream nextPutAll: testValue! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:00'!
replace1
	"Answer the value of replace1"

	^ replace1! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:00'!
replace1: anObject
	"Set the value of replace1"

	replace1 := anObject! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:00'!
replace2
	"Answer the value of replace2"

	^ replace2! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:00'!
replace2: anObject
	"Set the value of replace2"

	replace2 := anObject! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/28/2011 19:50'!
testValue
	"Answer the value of testValue"

	^ testValue! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/28/2011 19:50'!
testValue: anObject
	"Set the value of testValue"

	testValue := anObject! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 2/19/2011 00:51'!
listFields
	"Array of selectors to be sent to instances to match against entered search text"
	^self propertyAt: #listFields ifAbsent: [ Array with: self classes first instVarNames first ]! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 2/19/2011 00:51'!
listFields: anArray
	"Array of selectors to be sent to instances to match against search text entered into autocomplete component"
	^self propertyAt: #listFields put: anArray! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/25/2011 20:41'!
searchFields
	"Array of selectors to be sent to instances to match against entered search text"
	^self propertyAt: #searchFields ifAbsent: [ Array with: self classes first instVarNames first ]! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/25/2011 20:42'!
searchFields: anArray
	"Array of selectors to be sent to instances to match against search text entered into autocomplete component"
	^self propertyAt: #searchFields put: anArray! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/29/2011 12:44'!
updateId
	"Return an optional id to be updated onClose. Model object MUST implement an instance method that returns a description to be rendered in the update script"
	^self propertyAt: #updateId ifAbsent: [ nil ]! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/29/2011 12:46'!
updateId: aSymbol
	"Provide an optional id to be updated onClose. Model object MUST implement an instance method that returns a description (#descriptionASymbol) to be rendered in the update script."
	self propertyAt: #updateId put: aSymbol! !

!MADescriptionComponent methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 2/8/2011 20:25'!
isUndefined
	^false! !

MAExternalEditorComponent subclass: #MJAutocompleteComponent
	instanceVariableNames: 'items replaceIds listSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox'!

!MJAutocompleteComponent commentStamp: 'jmck 3/8/2011 21:37' prior: 0!
A MJAutocompleteComponent is a Magritte component for looking up an object on a MAToOneRelationDescription using the jQuery autocompleter.
Send #searchFields: to the description to search instances of model objects for matching text in any of the searchFields.
Send #listFields: to the description to produce the displayed string for the search list
listSelector is sent to the objectClass for custom list generation; defaults to #allInstances
Use #updateId: to have a script included which updates a div using the description returned by sending to the model object #descriptionASymbol, where 'aSymbol' is the supplied id. Kind of crazy I know...

replaceIds are used as follows: The description is searched for those descriptions which have a given replaceId in their properties. Given replaceIds = #(#a #b), there should be two OTHER descriptions, one each with  replaceId of #a or #b in their properties. When an object is selected from the list, it will be sent (perform:) the replaceIds for its corresponding values and those values will populate the described object written to it using its respective description. This is handy for populating defaults from a looked-up object. Say an item is looked up for an order, you would want the order line item updated with the looked-up item's price and cost say....



See functional test for an example.


Instance Variables
	items:		a 'temp' variable that stores the collection of found items for a search term. It is a cache to speed up the search for the selected item in #modelFor:
!

!MJAutocompleteComponent class methodsFor: 'as yet unclassified' stamp: 'jmck 1/24/2011 21:00'!
isAbstract
	^false! !

!MJAutocompleteComponent methodsFor: 'accessing-dynamic' stamp: 'jmck 3/8/2011 20:49'!
displayStringFor: aModel
	^aModel notNil
		ifTrue: [ String streamContents: [ :strm |
			self listFields
				do: [ :fld | | v | (v := aModel perform: fld) isNil ifFalse: [ strm nextPutAll: v asString ] ]
				separatedBy: [ strm nextPut: $ ] ] ]
		ifFalse: [ '' ]! !

!MJAutocompleteComponent methodsFor: 'initialization' stamp: 'jmck 1/29/2011 14:45'!
initialize
	super initialize.
	items := OrderedCollection new! !

!MJAutocompleteComponent methodsFor: 'accessing-dynamic' stamp: 'jmck 3/8/2011 21:39'!
listFields
	^description listFields ifNil: [ self searchFields ]! !

!MJAutocompleteComponent methodsFor: 'accessing' stamp: 'jmck 3/8/2011 21:09'!
listSelector
	"this will be sent to the lookup class to get the list to which the search  will apply"
	^listSelector ifNil: [ #allInstances ]! !

!MJAutocompleteComponent methodsFor: 'accessing' stamp: 'jmck 3/8/2011 21:06'!
listSelector: aSymbol
	"this will be sent to the lookup class to get the list to which the search  will apply"
	listSelector := aSymbol! !

!MJAutocompleteComponent methodsFor: 'lookup' stamp: 'jmck 2/1/2011 21:04'!
lookUp: aDivId
	| component selector |
	selector := ('description', aDivId capitalized) asSymbol.
	component :=  [ self value perform: selector ]
		on: Error
		do: [ ^MAUndefinedComponent new ].
	^component asComponentOn: self value! !

!MJAutocompleteComponent methodsFor: 'lookup' stamp: 'jmck 2/19/2011 00:56'!
modelFor: aTerm
	items isEmptyOrNil ifTrue: [ ^self value ].
	^items detect: [ :each | 
			(self displayStringFor: each) = aTerm ] ifNone: [ nil ] 
		! !

!MJAutocompleteComponent methodsFor: 'rendering' stamp: 'jmck 3/8/2011 20:54'!
renderEditorOn: html
	| id |
	id := self updateId.
	html textInput
			id: html lastId;
			attributeAt: 'autocomplete' put: 'off';
			class: 'ui-widget-content';
			value: (self displayStringFor: self value);
			callback: [ :text | self value: (self modelFor: text) ];
			script: (html jQuery this autocomplete
				sourceCallback: [ :term | self searchResult: term ];
				onClose: (html jQuery ajax
					serializeThis; 
					script: [ :s | self updateId: id on: s; replaceIdsOn: s ] )).
	id isNil
		ifFalse: [
			html div
				id: id;
				with: [ self value isNil ifFalse: [ html render: (self lookUp: id) ] ] ]
! !

!MJAutocompleteComponent methodsFor: 'lookup' stamp: 'jmck 2/1/2011 20:37'!
replaceIds
	^replaceIds
		ifNil: [ replaceIds := self description replaceIds
			collect: [ :id | 
				self parent children 
					detect: [ :each | each replaceId = id ]
					ifNone: [ MAUndefinedComponent new ] ] ]! !

!MJAutocompleteComponent methodsFor: 'rendering' stamp: 'jmck 3/8/2011 21:05'!
replaceIdsOn: aScript
	self replaceIds do: [ :component |
		component isUndefined
			ifFalse: [ aScript << ((aScript jQuery id: (component ajaxId: 'label'))
				replaceWith: component) ] ]! !

!MJAutocompleteComponent methodsFor: 'accessing-dynamic' stamp: 'jmck 1/24/2011 21:17'!
searchClass
	^description classes first! !

!MJAutocompleteComponent methodsFor: 'accessing-dynamic' stamp: 'jmck 1/24/2011 20:41'!
searchFields
	"Answer the value of searchFields"

	^ description searchFields! !

!MJAutocompleteComponent methodsFor: 'accessing-dynamic' stamp: 'jmck 3/8/2011 21:22'!
searchResult: searchTerm
	(searchTerm isNil or:[ searchTerm = '']) ifTrue: [ ^ #() ].
	items := (self searchClass perform: self listSelector)
		select: [ :each | 
			self searchFields anySatisfy: [ :fld | | value |
					value := each perform: fld.
					value notNil and: [ value asString asLowercase beginsWith: searchTerm asLowercase ] ] ].
	^items collect: [ :each | self displayStringFor: each ]
		
! !

!MJAutocompleteComponent methodsFor: 'lookup' stamp: 'jmck 1/29/2011 11:50'!
updateId
	^description updateId! !

!MJAutocompleteComponent methodsFor: 'rendering' stamp: 'jmck 3/8/2011 20:53'!
updateId: anId on: aScript
	anId isNil
		ifFalse: [ aScript << (aScript jQuery: anId) load
			html: (self lookUp: anId) ]! !

!MJAutocompleteComponent methodsFor: 'accessing-model' stamp: 'jmck 3/8/2011 20:44'!
value: anObject
	super value: anObject.
	anObject ifNil: [ ^self ].
	self replaceIds do: [ :component |
		component value: (anObject perform: component replaceId)]! !
MJFunctionalTest initialize!
